-- buPolyChop.mcr Ver.0.1
-- Kazuhiro Kasiwagi (kasiwagi (at) ummb.jp)
-- log
-- 0.1 first ver.

macroScript buPolyChop
	category:"Bu"
	buttontext:"polychop"
	toolTip:"buPolyChop"
(
    -- CONST
    local cutlimit = 3.0
    local anglelimit = 0.9

	local targetObj,loopF
	
	fn checkViewType = (
		case viewport.getType() of (
			#view_persp_user: false
			#view_camera: false
			#view_spot: false
			#view_shape: false
			default: true
		)
	)
	
	fn polychop mR1 mR2= (
		local sV = case subObjectLevel of (
						1: polyop.getVertSelection targetObj
						2: polyop.getVertsUsingEdge targetObj #selection
						3: polyop.getVertsUsingEdge targetObj #selection
						4: polyop.getVertsUsingFace targetObj #selection
						5: polyop.getVertsUsingFace targetObj #selection
						default: return()
					)
		local ap = cross (normalize (mR2.pos - mR1.pos)) mR1.dir
		for i in sV do (
            local n = [0,0,0]
            for j in polyop.getFacesUsingVert targetObj i do n += polyop.getFaceNormal targetObj j
            n = normalize n
            local vp = polyop.GetVert targetObj i
            local h = dot (vp - mR1.pos) ap
            if abs h < cutlimit do 
                if (dot n ap < -anglelimit and h < 0.0) or (dot n ap > anglelimit and h > 0.0) do
                    polyop.setVert targetObj i (vp - ap * h)
		)
	)
	
	tool mtPolychop(
		local mR,pAr=#()
		on mouseMove clickno do (
			pAr[2] = [viewPoint.x,viewPoint.y,0]
			CompleteRedraw()
			gw.wPolyline pAr false rgb:#(red,red)
			gw.enlargeUpdateRect #whole
			gw.updateScreen()
            gw.resetUpdateRect()
		)
		on mousePoint clickno do (
			if clickno == 1 then (
				mR = mapScreenToWorldRay viewPoint
				pAr[1] = [viewPoint.x,viewPoint.y,0]
			) else (
                polychop mR (mapScreenToWorldRay viewPoint)
				#stop
			)
		)
		on mouseAbort clickno do loopF = false
	)
	On IsEnabled Return Filters.Is_EPoly()
	On IsVisible Return Filters.Is_EPoly()
	On Execute do (
		enableUndo off
		loopF = true
		try (
            local oldser = showEndResult
            showEndResult = false
			if (targetObj = selection[1]) != undefined and checkViewType() and classof targetObj == Editable_Poly do
				while loopF do startTool mtPolychop
            showEndResult = oldser
		) catch ()
		enableUndo on
	)
)
